/* $Id: ICell.h,v 1.3 2004/05/09 01:36:19 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ICELL_H
#define __ICELL_H

#include "msg_recver.h"
#include "msg_sender.h"
#include "shape_sensor.h"
#include "messenger.h"
class Cell_data;
#include <string>

class ICell : public msg_recver, public msg_sender
{
 public:
	ICell(messenger *m, Cell_data *cd);
	virtual ~ICell();

	// Run cell for a step, this should do only a small amount of work
	virtual void step() = 0;
	// Return true iff cell is done with its job
	virtual bool done() const = 0;

 protected:
	// Output given text to stdout
	virtual void output(const std::string &text);
};

#endif // __ICELL_H
