/* $Id: delivered_msg.cpp,v 1.2 2004/05/09 01:36:19 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "delivered_msg.h"
#include <memory>
#include <assert.h>
using namespace std;

delivered_msg::delivered_msg()
	: direction(0),
	  strength(0)
{}

delivered_msg::delivered_msg(const delivered_msg &dm)
	: direction(dm.get_direction()),
	  strength(dm.get_strength()),
	  mc(dm.get_msg_content_copy())
{}

float delivered_msg::get_direction() const
{ return direction; }

void delivered_msg::set_direction(float d)
{
	assert(direction_min <= d && d <= direction_max);
	direction = d;
}


float delivered_msg::get_strength() const
{ return strength; }

void delivered_msg::set_strength(float s)
{
	assert(strength_min <= s && s <= strength_max);
	strength = s;
}


auto_ptr<msg_content> delivered_msg::get_msg_content_copy() const
{
	assert(mc.get());
	return auto_ptr<msg_content>(mc->clone());
}

auto_ptr<msg_content> delivered_msg::extract_msg_content()
{ return mc; }

void delivered_msg::set_msg_content(auto_ptr<msg_content> _mc)
{ mc = _mc; }


/*
const Cell_data* delivered_msg::get_sender() const
{ return sender; }

Cell_data* delivered_msg::get_sender()
{ return sender; }

void delivered_msg::set_sender(Cell_data *s)
{ sender = s; }
*/
