/* $Id: pbm_toolkit.h,v 1.2 2004/05/09 01:36:20 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __PBM_TOOLKIT_H
#define __PBM_TOOLKIT_H

#include <string>
#include <vector>

// PBM represents a given pbm file. See netpbm for more information on
// this image format.
// This class only supports "Plain PBM" without comments. Whitespace is allowed
class pbm
{
 public:
	pbm(const std::string &filename);

	std::string  get_magic_num();
	bool         correct_magic_num();
	unsigned int get_width();
	unsigned int get_height();

	std::vector< std::vector<bool> > get_image();
	// Same as get_image(), but scales image using pnmscale
	std::vector< std::vector<bool> > get_image(unsigned int width,
															 unsigned int height);

 private:
	const std::string filename;
};

#endif // __PBM_TOOLKIT_H
