/* $Id: scheduler.h,v 1.3 2004/05/09 01:36:20 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SCHEDULER_H
#define __SCHEDULER_H

#include "Cell_data.h"
#include "cd_list.h"

class scheduler
{
 public:
	scheduler(const cd_list_t *all_cells);

	Cell_data* next_cell();

	bool all_cells_done() const;

 private:
	void reschedule();
	bool check_and_mark_cell_done(Cell_data *cell);
	
	cd_list_t    nondone_cells;

	unsigned int num_cells_scheduled;
	unsigned int next_scheduled_cell_index;
	cd_list_t    cell_schedule;
};

#endif // __SCHEDULER_H
