/* $Id: utils.h,v 1.3 2004/05/09 01:36:20 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __UTILS_H
#define __UTILS_H

#include <string>

std::string itos(int x);
std::string uitos(unsigned int x);

std::string ftos(float x);
std::string dtos(double x);

std::string ptos(int *x);


// float compare functions
// WARNING: [less|more] than and equal are not mutually exclusive! FIXME?
#define F_COMPARE_TOL 0.0001
bool f_eq(float x, float y, double tol = F_COMPARE_TOL);
bool f_lt(float x, float y, double tol = F_COMPARE_TOL);
bool f_le(float x, float y, double tol = F_COMPARE_TOL);
bool f_gt(float x, float y, double tol = F_COMPARE_TOL);
bool f_ge(float x, float y, double tol = F_COMPARE_TOL);

// round x to the nearest integer
float round_float(float x);

#endif // __UTILS_H
